package sahoo.osgihttp.test1;

import javax.servlet.http.*;
import java.io.*;
import java.net.*;
import java.util.*;
import org.osgi.framework.BundleActivator;
import org.osgi.framework.Filter;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;
import org.osgi.service.http.HttpService;
import org.osgi.service.http.HttpContext;
import org.osgi.util.tracker.ServiceTracker;

public class Activator implements BundleActivator {

	private ServiceTracker httpServiceTracker;
	
	public void start(BundleContext context) throws Exception {
		httpServiceTracker = new HttpServiceTracker(context);
		httpServiceTracker.open();
	}

	public void stop(BundleContext context) throws Exception {
		httpServiceTracker.close();
		httpServiceTracker = null;
	}

	private class HttpServiceTracker extends ServiceTracker {

		public HttpServiceTracker(BundleContext context) throws Exception {
			super(context, context.createFilter("(&(objectClass=org.osgi.service.http.HttpService)(VirtualServer=server))"), null);
		}

		public Object addingService(ServiceReference reference) {
			HttpService httpService = (HttpService) context.getService(reference);
			try {			
				httpService.registerServlet("/aa/bb", new HelloWorldServlet1(), null, null);
				httpService.registerServlet("/aa", new HelloWorldServlet2(), null, null);
                                System.out.println("Registered servlet1 with mapping /aa/bb and servlet2 with mapping /aa");
                                test();
                                httpService.unregister("/aa/bb");
                                System.out.println("Unregistered servlet1");
                                test();
                                
			} catch (Exception e) {
				e.printStackTrace();
			}
			return httpService;
		}		
	}

        void test() {
            try {
                final String urlstr = "http://localhost:8080/osgi/aa/bb";
                URL source = null;
                String inputLine = new String();
                StringBuffer resbuf = new StringBuffer();
                BufferedReader in = null;
                source = new URL(urlstr);
                in = new BufferedReader(new InputStreamReader(source.openStream()));
                while ((inputLine = in.readLine()) != null) {
                        resbuf.append(inputLine);
                }
                in.close();
                System.out.println(resbuf.toString());
            } catch(Exception e) {
                System.out.println(e);
            }
        }
}
